package TekitoBasic
{
	import mx.containers.Canvas;
	import mx.controls.TextArea;
	
	public class TBCanvas extends Canvas
	{
		public var body_txt:TextArea;
		public function TBCanvas()
		{
			body_txt = new TextArea();
			this.addChild(body_txt);
			TBFunction.canvas = this;
		}
		override protected function updateDisplayList(unscaledWidth:Number,
													  unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth, unscaledHeight);	
			body_txt.width = unscaledWidth;
			body_txt.height = unscaledHeight;
		}
		public function Run(source:String):Boolean
		{
			var parser:TBParser = new TBParser();
			var lex:TBLex = new TBLex(parser);
			var mac:TBMachine = new TBMachine(parser);
			lex.splitAll(source);
			if (!parser.compile()) {
				body_txt.text = parser.error_message;
				body_txt.text += lex.toString() + "\n---\n";
				return false;
			}
			// body_txt.text += parser.topnode.getAllString();
			mac.run(parser.topnode);
			return true;
		}
	}
}