package TekitoBasic.nodes
{
	import TekitoBasic.*;
	
	public class TBNode implements ITBNode
	{
		public var token:TBToken;
		public var next:TBNode = null;
		public var items:Array = [];//of SyntaxNode
		public function TBNode()
		{
			this.token = new TBToken(0, "?", 0);
		}
		public function get length():int
		{
			var c:int = 1;
			var n:TBNode = this.next;
			while (n != null) {
				n = n.next;
				c++;
			}
			return c;
		}
		public function clone():TBNode
		{
			var r:TBNode = new TBNode();
			r.token = this.token.clone();
			for (var i:int = 0; i < this.items.length; i++) {
				r.items[i] = this.items[i];
			}
			return r;
		}
		public function getAllString(level:int = 0):String
		{
			var n:TBNode = this;
			var res:String = "";
			var indent:String = "";
			for (var i:int = 0; i < level; i++) indent += "  ";
			while (n != null) {
				if (n.token == null || n.token.value == null) {
					res += indent + "null\n";
				} else {
					trace(n.token.value);
					res += indent + n.token.value + "\n";
					if (n.items.length > 0) {
						for (var j:int = 0; j < n.items.length; j++) {
							res += n.items[j].getAllString(level+1);
						}
					}
				}
				n = n.next;
			}
			return res;
		}
		public function execute(mac:TBMachine):Object
		{
			return null;
		}
		public function asm(mac:TBMachine):String
		{
			return "";
		}
	}
}