package TekitoBasic.nodes
{
	import TekitoBasic.TBMachine;
	
	public class TBNodeCalc extends TBNode
	{
		protected var mac:TBMachine;
		protected var _left:Object = null;
		protected var _right:Object = null;
		override public function execute(mac:TBMachine):Object
		{
			_left = _right = null;
			this.mac = mac;
			var v:Object = calc();
			mac.pushValue(v);
			return v;
		}
		virtual protected function calc():Object
		{
			throw new Error("Abstaract calc");
		}		
		protected function get left():Object
		{
			if (_left != null) return _left;
			mac.run(this.items[0]);
			_left = mac.popValue();
			return _left;
		}
		protected function get right():Object
		{
			if (_right != null) return _right;
			mac.run(this.items[1]);
			_right = mac.popValue();
			return _right;
		}
	}
}