package TekitoBasic.nodes
{
	import TekitoBasic.TBMachine;
	import TekitoBasic.TBToken;
	import TekitoBasic.TBVariable;
	
	public class TBNodeFor extends TBNode
	{
		override public function execute(mac:TBMachine):Object
		{
			// get loop variable
			var v_token:TBToken = items[0] as TBToken;
			var it:TBVariable = mac.getVariable(v_token.value as String);
			// from_value
			mac.run(this.items[1] as TBNode);
			var from_v:Object = mac.popValue();
			// to_value
			mac.run(this.items[2] as TBNode);
			var to_v:Object = mac.popValue();
			// let
			it.value = from_v;
			// push loop counter
			var for_obj:Object = {
				"jump": this.next,
				"from": it,
				"to": to_v
			};
			trace("from", it.value);
			trace("to",to_v);
			mac.for_stack.push(for_obj);
			return null;
		}
	}
}