package TekitoBasic.nodes
{
	import TekitoBasic.TBMachine;
	import TekitoBasic.TBVariable;
	
	public class TBNodeGetArray extends TBNode
	{
		override public function execute(mac:TBMachine):Object
		{
			// eval expr
			mac.run(this.items[1]);
			var expr:Object = mac.popValue();
			// eval variable
			mac.run(this.items[0]);
			var variable:TBVariable = mac.popValue() as TBVariable;
			if (variable != null) {
				if (variable.value == null) {
					if (typeof(expr) == "string") {
						variable.value = new Object();
					} else {
						variable.value = new Array();
					}
				}
				if (variable.value[expr] == undefined) {
					variable.value[expr] = new TBVariable();
				}
				mac.pushValue(variable.value[expr]);
			} else {
				mac.pushValue(null);
			}
			return null;
		}		
	}
}