package TekitoBasic.nodes
{
	import TekitoBasic.TBMachine;
	import TekitoBasic.TBVariable;
	
	public class TBNodePushVariable extends TBNode
	{
		override public function execute(mac:TBMachine):Object
		{
			mac.run(items[0]);
			var v:TBVariable = mac.popValue() as TBVariable;
			if (v == null) {
				mac.pushValue(null);
				return null;
			}
			mac.pushValue(v.value);
			return v.value;
		}
	}
}