package TekitoBasic.nodes
{
	import TekitoBasic.TBMachine;
	import TekitoBasic.TBVariable;
	
	public class TBNodeNext extends TBNode
	{
		override public function execute(mac:TBMachine):Object
		{
			var for_obj:Object = mac.for_stack.pop();
			var jump:TBNode 	= for_obj["jump"];
			var from:TBVariable = for_obj["from"];
			var to_v:Object 	= for_obj["to"];
			from.value = int(from.value) + 1;
			if (from.value <= to_v) {
				mac.for_stack.push(for_obj);
				mac.jumpNode(jump);
			}
			return null;
		}
	}
}